blob: 562c57e6858b79aff074fcb7ab8c65fa2f110bc0 [file] [log] [blame]
Jonathan Niederc74c7202013-11-25 13:03:06 -08001# Test framework for git. See t/README for usage.
Junio C Hamanoe1970ce2005-05-13 22:50:32 -07002#
3# Copyright (c) 2005 Junio C Hamano
4#
Michal Sojka64b90322010-04-16 15:53:59 +02005# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
Junio C Hamanoe1970ce2005-05-13 22:50:32 -070017
Junio C Hamano3c8f12c2012-06-24 22:01:35 -070018# Test the binaries we have just built. The tests are kept in
19# t/ subdirectory and are run in 'trash directory' subdirectory.
20if test -z "$TEST_DIRECTORY"
21then
22 # We allow tests to override this, in case they want to run tests
23 # outside of t/, e.g. for running tests on the test library
24 # itself.
25 TEST_DIRECTORY=$(pwd)
Felipe Contreras85176d72013-11-17 23:12:43 -050026else
27 # ensure that TEST_DIRECTORY is an absolute path so that it
28 # is valid even if the current working directory is changed
29 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
Junio C Hamano3c8f12c2012-06-24 22:01:35 -070030fi
31if test -z "$TEST_OUTPUT_DIRECTORY"
32then
33 # Similarly, override this to store the test-results subdir
34 # elsewhere
35 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
36fi
37GIT_BUILD_DIR="$TEST_DIRECTORY"/..
38
Jeff Kingd0cc5792017-07-10 09:24:35 -040039# If we were built with ASAN, it may complain about leaks
40# of program-lifetime variables. Disable it by default to lower
41# the noise level. This needs to happen at the start of the script,
42# before we even do our "did we build git yet" check (since we don't
43# want that one to complain to stderr).
Jeff Kingbf1ce902017-07-10 09:24:39 -040044: ${ASAN_OPTIONS=detect_leaks=0:abort_on_error=1}
Jeff Kingd0cc5792017-07-10 09:24:35 -040045export ASAN_OPTIONS
46
Jeff King85b81b32017-09-05 09:04:04 -040047# If LSAN is in effect we _do_ want leak checking, but we still
48# want to abort so that we notice the problems.
49: ${LSAN_OPTIONS=abort_on_error=1}
50export LSAN_OPTIONS
51
Johannes Schindelin8abfdf42018-11-14 08:32:11 -080052if test ! -f "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
Ramkumar Ramachandra2006f0a2012-09-17 22:36:19 +053053then
Johannes Schindelin8abfdf42018-11-14 08:32:11 -080054 echo >&2 'error: GIT-BUILD-OPTIONS missing (has Git been built?).'
Ramkumar Ramachandra2006f0a2012-09-17 22:36:19 +053055 exit 1
56fi
Junio C Hamano3c8f12c2012-06-24 22:01:35 -070057. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
58export PERL_PATH SHELL_PATH
59
Junio C Hamanoc2116a12008-03-06 19:04:26 -080060################################################################
61# It appears that people try to run tests without building...
Johannes Schindelin8abfdf42018-11-14 08:32:11 -080062"${GIT_TEST_INSTALLED:-$GIT_BUILD_DIR}/git$X" >/dev/null
Junio C Hamanoe1970ce2005-05-13 22:50:32 -070063if test $? != 1
64then
Johannes Schindelined306e42018-11-14 08:32:10 -080065 if test -n "$GIT_TEST_INSTALLED"
66 then
67 echo >&2 "error: there is no working Git at '$GIT_TEST_INSTALLED'"
68 else
69 echo >&2 'error: you do not seem to have built git yet.'
70 fi
Pavel Roskind9bdd392005-08-10 22:10:01 -040071 exit 1
Junio C Hamanoe1970ce2005-05-13 22:50:32 -070072fi
Junio C Hamanoc2116a12008-03-06 19:04:26 -080073
SZEDER Gábor8cf58002019-01-05 02:08:55 +010074# Parse options while taking care to leave $@ intact, so we will still
75# have all the original command line options when executing the test
76# script again for '--tee' and '--verbose-log' below.
77store_arg_to=
78prev_opt=
79for opt
80do
81 if test -n "$store_arg_to"
82 then
83 eval $store_arg_to=\$opt
84 store_arg_to=
85 prev_opt=
86 continue
87 fi
88
89 case "$opt" in
90 -d|--d|--de|--deb|--debu|--debug)
91 debug=t ;;
92 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
93 immediate=t ;;
94 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
95 GIT_TEST_LONG=t; export GIT_TEST_LONG ;;
96 -r)
97 store_arg_to=run_list
98 ;;
99 --run=*)
100 run_list=${opt#--*=} ;;
101 -h|--h|--he|--hel|--help)
102 help=t ;;
103 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
104 verbose=t ;;
105 --verbose-only=*)
106 verbose_only=${opt#--*=}
107 ;;
108 -q|--q|--qu|--qui|--quie|--quiet)
109 # Ignore --quiet under a TAP::Harness. Saying how many tests
110 # passed without the ok/not ok details is always an error.
111 test -z "$HARNESS_ACTIVE" && quiet=t ;;
112 --with-dashes)
113 with_dashes=t ;;
Johannes Schindelindd167a32019-01-29 06:19:37 -0800114 --no-bin-wrappers)
115 no_bin_wrappers=t ;;
SZEDER Gábor8cf58002019-01-05 02:08:55 +0100116 --no-color)
117 color= ;;
118 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
119 valgrind=memcheck
120 tee=t
121 ;;
122 --valgrind=*)
123 valgrind=${opt#--*=}
124 tee=t
125 ;;
126 --valgrind-only=*)
127 valgrind_only=${opt#--*=}
128 tee=t
129 ;;
130 --tee)
131 tee=t ;;
132 --root=*)
133 root=${opt#--*=} ;;
134 --chain-lint)
135 GIT_TEST_CHAIN_LINT=1 ;;
136 --no-chain-lint)
137 GIT_TEST_CHAIN_LINT=0 ;;
138 -x)
139 trace=t ;;
140 -V|--verbose-log)
141 verbose_log=t
142 tee=t
143 ;;
Johannes Schindelin22231902019-01-29 06:19:27 -0800144 --write-junit-xml)
145 write_junit_xml=t
146 ;;
SZEDER Gáborfb7d1e32019-01-05 02:08:59 +0100147 --stress)
148 stress=t ;;
149 --stress=*)
Johannes Schindelinf5457372019-03-03 06:44:55 -0800150 echo "error: --stress does not accept an argument: '$opt'" >&2
151 echo "did you mean --stress-jobs=${opt#*=} or --stress-limit=${opt#*=}?" >&2
152 exit 1
153 ;;
154 --stress-jobs=*)
155 stress=t;
SZEDER Gáborfb7d1e32019-01-05 02:08:59 +0100156 stress=${opt#--*=}
157 case "$stress" in
SZEDER Gábor7d661e52019-02-11 20:58:03 +0100158 *[!0-9]*|0*|"")
Johannes Schindelinf5457372019-03-03 06:44:55 -0800159 echo "error: --stress-jobs=<N> requires the number of jobs to run" >&2
SZEDER Gáborfb7d1e32019-01-05 02:08:59 +0100160 exit 1
161 ;;
162 *) # Good.
163 ;;
164 esac
165 ;;
SZEDER Gábor76e27fb2019-02-08 12:50:45 +0100166 --stress-limit=*)
Johannes Schindelinde69e6f2019-03-03 06:44:54 -0800167 stress=t;
SZEDER Gábor76e27fb2019-02-08 12:50:45 +0100168 stress_limit=${opt#--*=}
169 case "$stress_limit" in
SZEDER Gábor7d661e52019-02-11 20:58:03 +0100170 *[!0-9]*|0*|"")
SZEDER Gábor76e27fb2019-02-08 12:50:45 +0100171 echo "error: --stress-limit=<N> requires the number of repetitions" >&2
172 exit 1
173 ;;
174 *) # Good.
175 ;;
176 esac
177 ;;
SZEDER Gábor8cf58002019-01-05 02:08:55 +0100178 *)
179 echo "error: unknown test option '$opt'" >&2; exit 1 ;;
180 esac
181
182 prev_opt=$opt
183done
184if test -n "$store_arg_to"
185then
186 echo "error: $prev_opt requires an argument" >&2
187 exit 1
188fi
189
190if test -n "$valgrind_only"
191then
192 test -z "$valgrind" && valgrind=memcheck
193 test -z "$verbose" && verbose_only="$valgrind_only"
194elif test -n "$valgrind"
195then
196 test -z "$verbose_log" && verbose=t
197fi
198
SZEDER Gáborfb7d1e32019-01-05 02:08:59 +0100199if test -n "$stress"
200then
201 verbose=t
202 trace=t
203 immediate=t
204fi
205
206TEST_STRESS_JOB_SFX="${GIT_TEST_STRESS_JOB_NR:+.stress-$GIT_TEST_STRESS_JOB_NR}"
SZEDER Gábor62c379b2019-01-05 02:08:56 +0100207TEST_NAME="$(basename "$0" .sh)"
208TEST_RESULTS_DIR="$TEST_OUTPUT_DIRECTORY/test-results"
SZEDER Gáborfb7d1e32019-01-05 02:08:59 +0100209TEST_RESULTS_BASE="$TEST_RESULTS_DIR/$TEST_NAME$TEST_STRESS_JOB_SFX"
210TRASH_DIRECTORY="trash directory.$TEST_NAME$TEST_STRESS_JOB_SFX"
SZEDER Gábor61f292d2019-01-05 02:08:57 +0100211test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
212case "$TRASH_DIRECTORY" in
213/*) ;; # absolute path is good
214 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
215esac
SZEDER Gábor62c379b2019-01-05 02:08:56 +0100216
SZEDER Gáborfb7d1e32019-01-05 02:08:59 +0100217# If --stress was passed, run this test repeatedly in several parallel loops.
218if test "$GIT_TEST_STRESS_STARTED" = "done"
219then
220 : # Don't stress test again.
221elif test -n "$stress"
222then
223 if test "$stress" != t
224 then
225 job_count=$stress
226 elif test -n "$GIT_TEST_STRESS_LOAD"
227 then
228 job_count="$GIT_TEST_STRESS_LOAD"
229 elif job_count=$(getconf _NPROCESSORS_ONLN 2>/dev/null) &&
230 test -n "$job_count"
231 then
232 job_count=$((2 * $job_count))
233 else
234 job_count=8
235 fi
236
237 mkdir -p "$TEST_RESULTS_DIR"
238 stressfail="$TEST_RESULTS_BASE.stress-failed"
239 rm -f "$stressfail"
240
241 stress_exit=0
242 trap '
243 kill $job_pids 2>/dev/null
244 wait
245 stress_exit=1
246 ' TERM INT HUP
247
248 job_pids=
249 job_nr=0
250 while test $job_nr -lt "$job_count"
251 do
252 (
253 GIT_TEST_STRESS_STARTED=done
254 GIT_TEST_STRESS_JOB_NR=$job_nr
255 export GIT_TEST_STRESS_STARTED GIT_TEST_STRESS_JOB_NR
256
257 trap '
258 kill $test_pid 2>/dev/null
259 wait
260 exit 1
261 ' TERM INT
262
SZEDER Gábor76e27fb2019-02-08 12:50:45 +0100263 cnt=1
264 while ! test -e "$stressfail" &&
265 { test -z "$stress_limit" ||
266 test $cnt -le $stress_limit ; }
SZEDER Gáborfb7d1e32019-01-05 02:08:59 +0100267 do
268 $TEST_SHELL_PATH "$0" "$@" >"$TEST_RESULTS_BASE.stress-$job_nr.out" 2>&1 &
269 test_pid=$!
270
271 if wait $test_pid
272 then
273 printf "OK %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
274 else
275 echo $GIT_TEST_STRESS_JOB_NR >>"$stressfail"
276 printf "FAIL %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
277 fi
278 cnt=$(($cnt + 1))
279 done
280 ) &
281 job_pids="$job_pids $!"
282 job_nr=$(($job_nr + 1))
283 done
284
285 wait
286
287 if test -f "$stressfail"
288 then
SZEDER Gábor76e27fb2019-02-08 12:50:45 +0100289 stress_exit=1
SZEDER Gáborfb7d1e32019-01-05 02:08:59 +0100290 echo "Log(s) of failed test run(s):"
291 for failed_job_nr in $(sort -n "$stressfail")
292 do
293 echo "Contents of '$TEST_RESULTS_BASE.stress-$failed_job_nr.out':"
294 cat "$TEST_RESULTS_BASE.stress-$failed_job_nr.out"
295 done
296 rm -rf "$TRASH_DIRECTORY.stress-failed"
297 # Move the last one.
298 mv "$TRASH_DIRECTORY.stress-$failed_job_nr" "$TRASH_DIRECTORY.stress-failed"
299 fi
300
301 exit $stress_exit
302fi
303
Ramkumar Ramachandra4cde5192012-09-22 10:25:10 +0530304# if --tee was passed, write the output not only to the terminal, but
305# additionally to the file test-results/$BASENAME.out, too.
SZEDER Gábor8cf58002019-01-05 02:08:55 +0100306if test "$GIT_TEST_TEE_STARTED" = "done"
307then
308 : # do not redirect again
309elif test -n "$tee"
310then
SZEDER Gábor62c379b2019-01-05 02:08:56 +0100311 mkdir -p "$TEST_RESULTS_DIR"
Jeff King452320f2016-10-21 06:48:00 -0400312
313 # Make this filename available to the sub-process in case it is using
314 # --verbose-log.
SZEDER Gábor62c379b2019-01-05 02:08:56 +0100315 GIT_TEST_TEE_OUTPUT_FILE=$TEST_RESULTS_BASE.out
Jeff King452320f2016-10-21 06:48:00 -0400316 export GIT_TEST_TEE_OUTPUT_FILE
317
318 # Truncate before calling "tee -a" to get rid of the results
319 # from any previous runs.
320 >"$GIT_TEST_TEE_OUTPUT_FILE"
321
Jeff King3f824e92017-12-08 05:47:22 -0500322 (GIT_TEST_TEE_STARTED=done ${TEST_SHELL_PATH} "$0" "$@" 2>&1;
SZEDER Gábor62c379b2019-01-05 02:08:56 +0100323 echo $? >"$TEST_RESULTS_BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
324 test "$(cat "$TEST_RESULTS_BASE.exit")" = 0
Ramkumar Ramachandra4cde5192012-09-22 10:25:10 +0530325 exit
SZEDER Gábor8cf58002019-01-05 02:08:55 +0100326fi
327
328if test -n "$trace" && test -n "$test_untraceable"
329then
330 # '-x' tracing requested, but this test script can't be reliably
331 # traced, unless it is run with a Bash version supporting
332 # BASH_XTRACEFD (introduced in Bash v4.1).
333 #
334 # Perform this version check _after_ the test script was
335 # potentially re-executed with $TEST_SHELL_PATH for '--tee' or
336 # '--verbose-log', so the right shell is checked and the
337 # warning is issued only once.
338 if test -n "$BASH_VERSION" && eval '
339 test ${BASH_VERSINFO[0]} -gt 4 || {
340 test ${BASH_VERSINFO[0]} -eq 4 &&
341 test ${BASH_VERSINFO[1]} -ge 1
342 }
343 '
344 then
345 : Executed by a Bash version supporting BASH_XTRACEFD. Good.
346 else
347 echo >&2 "warning: ignoring -x; '$0' is untraceable without BASH_XTRACEFD"
348 trace=
349 fi
350fi
351if test -n "$trace" && test -z "$verbose_log"
352then
353 verbose=t
354fi
Ramkumar Ramachandra4cde5192012-09-22 10:25:10 +0530355
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700356# For repeatability, reset the environment to known value.
Richard Hansend5c1b7c2015-06-17 17:11:21 -0400357# TERM is sanitized below, after saving color control sequences.
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700358LANG=C
359LC_ALL=C
360PAGER=cat
361TZ=UTC
Richard Hansend5c1b7c2015-06-17 17:11:21 -0400362export LANG LC_ALL PAGER TZ
Eric Wong8ff99e72006-07-11 12:01:54 -0700363EDITOR=:
Ævar Arnfjörð Bjarmason6cdccfc2018-11-08 21:15:29 +0000364
365# GIT_TEST_GETTEXT_POISON should not influence git commands executed
366# during initialization of test-lib and the test repo. Back it up,
367# unset and then restore after initialization is finished.
368if test -n "$GIT_TEST_GETTEXT_POISON"
369then
370 GIT_TEST_GETTEXT_POISON_ORIG=$GIT_TEST_GETTEXT_POISON
371 unset GIT_TEST_GETTEXT_POISON
372fi
373
Stefano Lattarini661bfd12012-03-02 19:48:36 +0100374# A call to "unset" with no arguments causes at least Solaris 10
375# /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
376# deriving from the command substitution clustered with the other
377# ones.
Junio C Hamano3c8f12c2012-06-24 22:01:35 -0700378unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
Jonathan Nieder95a1d122011-03-15 05:10:45 -0500379 my @env = keys %ENV;
Jens Lehmann730477f2011-03-28 21:16:09 +0200380 my $ok = join("|", qw(
381 TRACE
382 DEBUG
Jens Lehmann730477f2011-03-28 21:16:09 +0200383 TEST
384 .*_TEST
385 PROVE
386 VALGRIND
René Scharfeac001282013-01-06 18:47:57 +0100387 UNZIP
Nguyễn Thái Ngọc Duyedb54082013-01-15 20:50:56 +0700388 PERF_
Jeff Kinge2a0ccc2014-05-22 05:28:50 -0400389 CURL_VERBOSE
Elia Pinto4527aa12016-09-05 10:24:42 +0000390 TRACE_CURL
Jens Lehmann730477f2011-03-28 21:16:09 +0200391 ));
392 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
Jonathan Nieder95a1d122011-03-15 05:10:45 -0500393 print join("\n", @vars);
394')
Genki Sky7976e902018-02-15 21:46:04 -0500395unset XDG_CACHE_HOME
Jeff King5adf84e2012-07-24 07:53:05 -0400396unset XDG_CONFIG_HOME
Benoit Person8bade1e2013-07-04 22:38:55 +0200397unset GITPERLLIB
Junio C Hamano29e55cd2006-02-10 19:11:23 -0800398GIT_AUTHOR_EMAIL=author@example.com
399GIT_AUTHOR_NAME='A U Thor'
Junio C Hamano29e55cd2006-02-10 19:11:23 -0800400GIT_COMMITTER_EMAIL=committer@example.com
401GIT_COMMITTER_NAME='C O Mitter'
Shawn O. Pearce8d0fc482007-02-04 00:45:47 -0500402GIT_MERGE_VERBOSITY=5
Junio C Hamanof8246282012-01-10 22:44:45 -0800403GIT_MERGE_AUTOEDIT=no
404export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
Junio C Hamano29e55cd2006-02-10 19:11:23 -0800405export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
406export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
Jonathan Niederd33738d2009-11-11 17:56:07 -0600407export EDITOR
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700408
Karsten Blees124647c2014-07-12 02:03:01 +0200409# Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
410GIT_TRACE_BARE=1
411export GIT_TRACE_BARE
412
Ben Peart4cb54d02018-09-18 23:29:35 +0000413check_var_migration () {
Junio C Hamano4231d1b2018-09-20 11:43:43 -0700414 # the warnings and hints given from this helper depends
415 # on end-user settings, which will disrupt the self-test
416 # done on the test framework itself.
417 case "$GIT_TEST_FRAMEWORK_SELFTEST" in
418 t) return ;;
419 esac
420
Ben Peart4cb54d02018-09-18 23:29:35 +0000421 old_name=$1 new_name=$2
422 eval "old_isset=\${${old_name}:+isset}"
423 eval "new_isset=\${${new_name}:+isset}"
Junio C Hamano4231d1b2018-09-20 11:43:43 -0700424
Ben Peart4cb54d02018-09-18 23:29:35 +0000425 case "$old_isset,$new_isset" in
426 isset,)
427 echo >&2 "warning: $old_name is now $new_name"
428 echo >&2 "hint: set $new_name too during the transition period"
429 eval "$new_name=\$$old_name"
430 ;;
431 isset,isset)
432 # do this later
433 # echo >&2 "warning: $old_name is now $new_name"
434 # echo >&2 "hint: remove $old_name"
435 ;;
436 esac
437}
438
439check_var_migration GIT_FSMONITOR_TEST GIT_TEST_FSMONITOR
Ben Peart1f357b02018-09-18 23:29:36 +0000440check_var_migration TEST_GIT_INDEX_VERSION GIT_TEST_INDEX_VERSION
Ben Peart5765d972018-09-18 23:29:37 +0000441check_var_migration GIT_FORCE_PRELOAD_TEST GIT_TEST_PRELOAD_INDEX
Ben Peart1f357b02018-09-18 23:29:36 +0000442
443# Use specific version of the index file format
444if test -n "${GIT_TEST_INDEX_VERSION:+isset}"
Thomas Gummerer5d9fc882014-02-23 21:49:58 +0100445then
Ben Peart1f357b02018-09-18 23:29:36 +0000446 GIT_INDEX_VERSION="$GIT_TEST_INDEX_VERSION"
Thomas Gummerer5d9fc882014-02-23 21:49:58 +0100447 export GIT_INDEX_VERSION
448fi
449
Elia Pintoa731fa92012-09-14 09:54:22 -0700450# Add libc MALLOC and MALLOC_PERTURB test
451# only if we are not executing the test with valgrind
SZEDER Gábor8cf58002019-01-05 02:08:55 +0100452if test -n "$valgrind" ||
René Scharfeee1431b2012-09-26 22:16:39 +0200453 test -n "$TEST_NO_MALLOC_CHECK"
Junio C Hamano1b3185f2012-09-14 20:38:24 -0700454then
455 setup_malloc_check () {
456 : nothing
457 }
458 teardown_malloc_check () {
459 : nothing
460 }
461else
462 setup_malloc_check () {
463 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
464 export MALLOC_CHECK_ MALLOC_PERTURB_
465 }
466 teardown_malloc_check () {
467 unset MALLOC_CHECK_ MALLOC_PERTURB_
468 }
469fi
Elia Pintoa731fa92012-09-14 09:54:22 -0700470
Junio C Hamano886a3902007-04-24 11:21:47 -0700471# Protect ourselves from common misconfiguration to export
472# CDPATH into the environment
473unset CDPATH
474
Bert Wesarg5565f472009-11-18 17:15:19 +0100475unset GREP_OPTIONS
René Scharfeac001282013-01-06 18:47:57 +0100476unset UNZIP
Bert Wesarg5565f472009-11-18 17:15:19 +0100477
Robin Rosenberg3d5c0cc2006-09-23 00:35:20 +0200478case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
Ramsay Jones1c0cc752012-09-01 19:11:49 +01004791|2|true)
Jeff King025232e2015-03-13 00:50:56 -0400480 GIT_TRACE=4
Ramsay Jones1c0cc752012-09-01 19:11:49 +0100481 ;;
Christian Couder6ce4e612006-09-02 18:23:48 +0200482esac
483
Junio C Hamanocd3c0952009-09-20 11:10:14 -0700484# Convenience
485#
Charles Bailey5555a2a2017-11-12 15:25:23 +0000486# A regexp to match 5, 35 and 40 hexdigits
Junio C Hamanocd3c0952009-09-20 11:10:14 -0700487_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
Charles Bailey5555a2a2017-11-12 15:25:23 +0000488_x35="$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
489_x40="$_x35$_x05"
Junio C Hamanocd3c0952009-09-20 11:10:14 -0700490
Junio C Hamano3749fde2011-04-23 22:34:13 -0700491# Zero SHA-1
492_z40=0000000000000000000000000000000000000000
493
brian m. carlsonbd981d52018-05-13 02:24:14 +0000494OID_REGEX="$_x40"
brian m. carlson198857b2018-05-13 02:24:12 +0000495ZERO_OID=$_z40
Nguyễn Thái Ngọc Duyf9e7d9f2016-07-16 07:06:24 +0200496EMPTY_TREE=4b825dc642cb6eb9a060e54bf8d69288fbee4904
Nguyễn Thái Ngọc Duy378932d2016-07-16 07:06:25 +0200497EMPTY_BLOB=e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
Nguyễn Thái Ngọc Duyf9e7d9f2016-07-16 07:06:24 +0200498
Junio C Hamano3f4ab622011-08-08 11:51:00 -0700499# Line feed
500LF='
501'
502
Jeff Kinga42643a2014-12-15 18:15:20 -0500503# UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
504# when case-folding filenames
505u200c=$(printf '\342\200\214')
506
brian m. carlsonbd981d52018-05-13 02:24:14 +0000507export _x05 _x35 _x40 _z40 LF u200c EMPTY_TREE EMPTY_BLOB ZERO_OID OID_REGEX
Thomas Rast342e9ef2012-02-17 11:25:09 +0100508
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700509# Each test should start with something like this, after copyright notices:
510#
511# test_description='Description of this test...
512# This test checks if command xyzzy does the right thing...
513# '
514# . ./test-lib.sh
Richard Hansend5c1b7c2015-06-17 17:11:21 -0400515test "x$TERM" != "xdumb" && (
Richard Hansenca92a662015-06-17 15:06:25 -0400516 test -t 1 &&
517 tput bold >/dev/null 2>&1 &&
518 tput setaf 1 >/dev/null 2>&1 &&
519 tput sgr0 >/dev/null 2>&1
520 ) &&
521 color=t
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700522
Richard Hansenca92a662015-06-17 15:06:25 -0400523if test -n "$color"
524then
Richard Hansend5c1b7c2015-06-17 17:11:21 -0400525 # Save the color control sequences now rather than run tput
526 # each time say_color() is called. This is done for two
527 # reasons:
528 # * TERM will be changed to dumb
529 # * HOME will be changed to a temporary directory and tput
530 # might need to read ~/.terminfo from the original HOME
531 # directory to get the control sequences
532 # Note: This approach assumes the control sequences don't end
533 # in a newline for any terminal of interest (command
534 # substitutions strip trailing newlines). Given that most
535 # (all?) terminals in common use are related to ECMA-48, this
536 # shouldn't be a problem.
537 say_color_error=$(tput bold; tput setaf 1) # bold red
538 say_color_skip=$(tput setaf 4) # blue
539 say_color_warn=$(tput setaf 3) # brown/yellow
540 say_color_pass=$(tput setaf 2) # green
541 say_color_info=$(tput setaf 6) # cyan
542 say_color_reset=$(tput sgr0)
543 say_color_="" # no formatting for normal text
Richard Hansenca92a662015-06-17 15:06:25 -0400544 say_color () {
Richard Hansend5c1b7c2015-06-17 17:11:21 -0400545 test -z "$1" && test -n "$quiet" && return
546 eval "say_color_color=\$say_color_$1"
Richard Hansenca92a662015-06-17 15:06:25 -0400547 shift
Richard Hansend5c1b7c2015-06-17 17:11:21 -0400548 printf "%s\\n" "$say_color_color$*$say_color_reset"
Richard Hansenca92a662015-06-17 15:06:25 -0400549 }
550else
551 say_color() {
552 test -z "$1" && test -n "$quiet" && return
553 shift
554 printf "%s\n" "$*"
555 }
556fi
557
Richard Hansend5c1b7c2015-06-17 17:11:21 -0400558TERM=dumb
559export TERM
560
Pierre Habouzit55db1df2007-10-24 22:03:38 +0200561error () {
562 say_color error "error: $*"
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +0200563 GIT_EXIT_OK=t
Pierre Habouzit55db1df2007-10-24 22:03:38 +0200564 exit 1
565}
566
SZEDER Gábor165293a2018-11-19 14:13:26 +0100567BUG () {
568 error >&7 "bug in the test script: $*"
569}
570
Pierre Habouzit55db1df2007-10-24 22:03:38 +0200571say () {
572 say_color info "$*"
573}
574
Jeff King614fe012016-10-22 00:45:06 -0400575if test -n "$HARNESS_ACTIVE"
576then
577 if test "$verbose" = t || test -n "$verbose_only"
578 then
579 printf 'Bail out! %s\n' \
580 'verbose mode forbidden under TAP harness; try --verbose-log'
581 exit 1
582 fi
583fi
584
Michele Ballabio570f3222007-11-10 15:17:25 +0100585test "${test_description}" != "" ||
586error "Test script did not set test_description."
587
588if test "$help" = "t"
589then
Uwe Storbeckcb1aefd2014-03-18 01:14:11 +0100590 printf '%s\n' "$test_description"
Michele Ballabio570f3222007-11-10 15:17:25 +0100591 exit 0
592fi
593
Pavel Roskin4d9d62f2005-08-10 23:56:21 -0400594exec 5>&1
Jeff King781f76b2011-12-15 01:55:29 -0500595exec 6<&0
SZEDER Gábor4ecae3c2017-03-18 17:13:59 +0100596exec 7>&2
Jeff King452320f2016-10-21 06:48:00 -0400597if test "$verbose_log" = "t"
598then
599 exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
600elif test "$verbose" = "t"
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700601then
602 exec 4>&2 3>&1
603else
604 exec 4>/dev/null 3>/dev/null
605fi
606
Jeff Kingd88785e2016-05-11 09:44:04 -0400607# Send any "-x" output directly to stderr to avoid polluting tests
608# which capture stderr. We can do this unconditionally since it
609# has no effect if tracing isn't turned on.
610#
611# Note that this sets up the trace fd as soon as we assign the variable, so it
612# must come after the creation of descriptor 4 above. Likewise, we must never
613# unset this, as it has the side effect of closing descriptor 4, which we
614# use to show verbose tests to the user.
615#
616# Note also that we don't need or want to export it. The tracing is local to
617# this shell, and we would not want to influence any shells we exec.
618BASH_XTRACEFD=4
619
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700620test_failure=0
621test_count=0
Junio C Hamano41ac4142008-02-01 01:50:53 -0800622test_fixed=0
623test_broken=0
Sverre Rabbelier2d84e9f2008-06-08 16:04:33 +0200624test_success=0
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700625
Ævar Arnfjörð Bjarmasond998bd42010-06-24 17:44:46 +0000626test_external_has_tap=0
627
Clemens Buchacherfaa4bc32008-02-27 20:28:45 +0100628die () {
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +0200629 code=$?
630 if test -n "$GIT_EXIT_OK"
631 then
632 exit $code
633 else
634 echo >&5 "FATAL: Unexpected exit with code $code"
635 exit 1
636 fi
Clemens Buchacherfaa4bc32008-02-27 20:28:45 +0100637}
638
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +0200639GIT_EXIT_OK=
Markus Heidelberg35641312009-01-20 00:43:26 +0100640trap 'die' EXIT
SZEDER Gábord45cec42018-12-30 20:16:22 +0100641trap 'exit $?' INT TERM HUP
Pavel Roskin41184272005-08-11 12:00:40 -0400642
Thomas Rast12a29b12012-02-17 11:25:08 +0100643# The user-facing functions are loaded from a separate file so that
644# test_perf subshells can have them too
Junio C Hamano3c8f12c2012-06-24 22:01:35 -0700645. "$TEST_DIRECTORY/test-lib-functions.sh"
Jonathan Nieder05236a52010-10-17 02:36:58 +0800646
Junio C Hamano886856a2005-05-14 00:24:27 -0700647# You are not expected to call test_ok_ and test_failure_ directly, use
Torstein Hegge3fa36662013-10-27 10:56:33 +0100648# the test_expect_* functions instead.
Junio C Hamano886856a2005-05-14 00:24:27 -0700649
650test_ok_ () {
Johannes Schindelin22231902019-01-29 06:19:27 -0800651 if test -n "$write_junit_xml"
652 then
653 write_junit_xml_testcase "$*"
654 fi
Johannes Sixtd5d9de12009-02-05 20:59:27 +0100655 test_success=$(($test_success + 1))
Thomas Rast633fe502013-10-19 23:06:08 +0200656 say_color "" "ok $test_count - $@"
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700657}
658
Junio C Hamano886856a2005-05-14 00:24:27 -0700659test_failure_ () {
Johannes Schindelin22231902019-01-29 06:19:27 -0800660 if test -n "$write_junit_xml"
661 then
662 junit_insert="<failure message=\"not ok $test_count -"
663 junit_insert="$junit_insert $(xml_attr_encode "$1")\">"
664 junit_insert="$junit_insert $(xml_attr_encode \
Johannes Schindelinaf9912e2019-01-29 06:19:34 -0800665 "$(if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
666 then
667 test-tool path-utils skip-n-bytes \
668 "$GIT_TEST_TEE_OUTPUT_FILE" $GIT_TEST_TEE_OFFSET
669 else
670 printf '%s\n' "$@" | sed 1d
671 fi)")"
Johannes Schindelin22231902019-01-29 06:19:27 -0800672 junit_insert="$junit_insert</failure>"
Johannes Schindelinaf9912e2019-01-29 06:19:34 -0800673 if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
674 then
675 junit_insert="$junit_insert<system-err>$(xml_attr_encode \
676 "$(cat "$GIT_TEST_TEE_OUTPUT_FILE")")</system-err>"
677 fi
Johannes Schindelin22231902019-01-29 06:19:27 -0800678 write_junit_xml_testcase "$1" " $junit_insert"
679 fi
Johannes Sixtd5d9de12009-02-05 20:59:27 +0100680 test_failure=$(($test_failure + 1))
Thomas Rast633fe502013-10-19 23:06:08 +0200681 say_color error "not ok $test_count - $1"
Junio C Hamanobf0dd8a2005-07-22 19:09:34 -0700682 shift
Uwe Storbeckcb1aefd2014-03-18 01:14:11 +0100683 printf '%s\n' "$*" | sed -e 's/^/# /'
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +0200684 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
Junio C Hamano886856a2005-05-14 00:24:27 -0700685}
686
Junio C Hamano41ac4142008-02-01 01:50:53 -0800687test_known_broken_ok_ () {
Johannes Schindelin22231902019-01-29 06:19:27 -0800688 if test -n "$write_junit_xml"
689 then
690 write_junit_xml_testcase "$* (breakage fixed)"
691 fi
Junio C Hamano41ac4142008-02-01 01:50:53 -0800692 test_fixed=$(($test_fixed+1))
Thomas Rast633fe502013-10-19 23:06:08 +0200693 say_color error "ok $test_count - $@ # TODO known breakage vanished"
Junio C Hamano41ac4142008-02-01 01:50:53 -0800694}
695
696test_known_broken_failure_ () {
Johannes Schindelin22231902019-01-29 06:19:27 -0800697 if test -n "$write_junit_xml"
698 then
699 write_junit_xml_testcase "$* (known breakage)"
700 fi
Junio C Hamano41ac4142008-02-01 01:50:53 -0800701 test_broken=$(($test_broken+1))
Thomas Rast633fe502013-10-19 23:06:08 +0200702 say_color warn "not ok $test_count - $@ # TODO known breakage"
Junio C Hamano41ac4142008-02-01 01:50:53 -0800703}
Junio C Hamano886856a2005-05-14 00:24:27 -0700704
705test_debug () {
Junio C Hamano8e832eb2005-08-10 22:53:27 -0700706 test "$debug" = "" || eval "$1"
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700707}
708
Thomas Raste6a6ddc2013-06-18 14:25:58 +0200709match_pattern_list () {
710 arg="$1"
711 shift
712 test -z "$*" && return 1
713 for pattern_
714 do
715 case "$arg" in
716 $pattern_)
717 return 0
718 esac
719 done
720 return 1
721}
722
Ilya Bobyr0445e6f2014-04-30 02:50:44 -0700723match_test_selector_list () {
724 title="$1"
725 shift
726 arg="$1"
727 shift
728 test -z "$1" && return 0
729
730 # Both commas and whitespace are accepted as separators.
731 OLDIFS=$IFS
732 IFS=' ,'
733 set -- $1
734 IFS=$OLDIFS
735
736 # If the first selector is negative we include by default.
737 include=
738 case "$1" in
739 !*) include=t ;;
740 esac
741
742 for selector
743 do
744 orig_selector=$selector
745
746 positive=t
747 case "$selector" in
748 !*)
749 positive=
750 selector=${selector##?}
751 ;;
752 esac
753
754 test -z "$selector" && continue
755
756 case "$selector" in
757 *-*)
758 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
759 then
760 echo "error: $title: invalid non-numeric in range" \
761 "start: '$orig_selector'" >&2
762 exit 1
763 fi
764 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
765 then
766 echo "error: $title: invalid non-numeric in range" \
767 "end: '$orig_selector'" >&2
768 exit 1
769 fi
770 ;;
771 *)
772 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
773 then
774 echo "error: $title: invalid non-numeric in test" \
775 "selector: '$orig_selector'" >&2
776 exit 1
777 fi
778 esac
779
780 # Short cut for "obvious" cases
781 test -z "$include" && test -z "$positive" && continue
782 test -n "$include" && test -n "$positive" && continue
783
784 case "$selector" in
785 -*)
786 if test $arg -le ${selector#-}
787 then
788 include=$positive
789 fi
790 ;;
791 *-)
792 if test $arg -ge ${selector%-}
793 then
794 include=$positive
795 fi
796 ;;
797 *-*)
798 if test ${selector%%-*} -le $arg \
799 && test $arg -le ${selector#*-}
800 then
801 include=$positive
802 fi
803 ;;
804 *)
805 if test $arg -eq $selector
806 then
807 include=$positive
808 fi
809 ;;
810 esac
811 done
812
813 test -n "$include"
814}
815
Thomas Rastff09af32013-06-23 20:12:56 +0200816maybe_teardown_verbose () {
817 test -z "$verbose_only" && return
818 exec 4>/dev/null 3>/dev/null
819 verbose=
820}
821
822last_verbose=t
823maybe_setup_verbose () {
824 test -z "$verbose_only" && return
Thomas Rast26a07302013-10-19 23:06:07 +0200825 if match_pattern_list $test_count $verbose_only
Thomas Rastff09af32013-06-23 20:12:56 +0200826 then
827 exec 4>&2 3>&1
828 # Emit a delimiting blank line when going from
829 # non-verbose to verbose. Within verbose mode the
830 # delimiter is printed by test_expect_*. The choice
831 # of the initial $last_verbose is such that before
832 # test 1, we do not print it.
833 test -z "$last_verbose" && echo >&3 ""
834 verbose=t
835 else
836 exec 4>/dev/null 3>/dev/null
837 verbose=
838 fi
839 last_verbose=$verbose
840}
841
Thomas Rast5dfc3682013-06-23 20:12:57 +0200842maybe_teardown_valgrind () {
843 test -z "$GIT_VALGRIND" && return
844 GIT_VALGRIND_ENABLED=
845}
846
847maybe_setup_valgrind () {
848 test -z "$GIT_VALGRIND" && return
Thomas Rast26a07302013-10-19 23:06:07 +0200849 if test -z "$valgrind_only"
Thomas Rast5dfc3682013-06-23 20:12:57 +0200850 then
851 GIT_VALGRIND_ENABLED=t
852 return
853 fi
854 GIT_VALGRIND_ENABLED=
855 if match_pattern_list $test_count $valgrind_only
856 then
857 GIT_VALGRIND_ENABLED=t
858 fi
859}
860
Jeff King9b5fe782015-08-06 01:33:57 -0400861want_trace () {
Jeff Kingf5ba2de2017-12-08 05:47:17 -0500862 test "$trace" = t && {
863 test "$verbose" = t || test "$verbose_log" = t
864 }
Jeff King9b5fe782015-08-06 01:33:57 -0400865}
866
Jeff Kinga136f6d2014-10-10 02:47:27 -0400867# This is a separate function because some tests use
868# "return" to end a test_expect_success block early
869# (and we want to make sure we run any cleanup like
870# "set +x").
871test_eval_inner_ () {
872 # Do not add anything extra (including LF) after '$*'
873 eval "
Jeff King9b5fe782015-08-06 01:33:57 -0400874 want_trace && set -x
Jeff Kinga136f6d2014-10-10 02:47:27 -0400875 $*"
876}
877
Jonathan Niedera7c58f22011-08-08 03:17:09 +0200878test_eval_ () {
Jeff King90c8a1d2017-12-08 05:47:08 -0500879 # If "-x" tracing is in effect, then we want to avoid polluting stderr
880 # with non-test commands. But once in "set -x" mode, we cannot prevent
Jeff Kinga136f6d2014-10-10 02:47:27 -0400881 # the shell from printing the "set +x" to turn it off (nor the saving
882 # of $? before that). But we can make sure that the output goes to
883 # /dev/null.
884 #
Jeff King90c8a1d2017-12-08 05:47:08 -0500885 # There are a few subtleties here:
886 #
887 # - we have to redirect descriptor 4 in addition to 2, to cover
888 # BASH_XTRACEFD
889 #
890 # - the actual eval has to come before the redirection block (since
891 # it needs to see descriptor 4 to set up its stderr)
892 #
893 # - likewise, any error message we print must be outside the block to
894 # access descriptor 4
895 #
896 # - checking $? has to come immediately after the eval, but it must
897 # be _inside_ the block to avoid polluting the "set -x" output
898 #
899
900 test_eval_inner_ "$@" </dev/null >&3 2>&4
Jeff Kinga136f6d2014-10-10 02:47:27 -0400901 {
Jeff Kinga136f6d2014-10-10 02:47:27 -0400902 test_eval_ret_=$?
Jeff King9b5fe782015-08-06 01:33:57 -0400903 if want_trace
Jeff Kinga136f6d2014-10-10 02:47:27 -0400904 then
905 set +x
Jeff Kinga136f6d2014-10-10 02:47:27 -0400906 fi
Jeff King90c8a1d2017-12-08 05:47:08 -0500907 } 2>/dev/null 4>&2
908
909 if test "$test_eval_ret_" != 0 && want_trace
910 then
911 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
912 fi
Jeff Kinga136f6d2014-10-10 02:47:27 -0400913 return $test_eval_ret_
Jonathan Niedera7c58f22011-08-08 03:17:09 +0200914}
915
Pavel Roskin4d9d62f2005-08-10 23:56:21 -0400916test_run_ () {
Jonathan Niederb6b0afd2010-05-06 03:41:10 -0500917 test_cleanup=:
Junio C Hamanob5867442011-06-27 11:02:22 -0700918 expecting_failure=$2
Jeff Kingbb79af92015-03-20 06:05:48 -0400919
Jeff King92b269f2015-04-22 16:09:57 -0400920 if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
Jeff King2a01ef82015-08-06 01:31:47 -0400921 # turn off tracing for this test-eval, as it simply creates
922 # confusing noise in the "-x" output
923 trace_tmp=$trace
924 trace=
Jeff Kingbb79af92015-03-20 06:05:48 -0400925 # 117 is magic because it is unlikely to match the exit
926 # code of other programs
Eric Sunshine878f9882018-07-11 02:46:33 -0400927 if $(printf '%s\n' "$1" | sed -f "$GIT_BUILD_DIR/t/chainlint.sed" | grep -q '?![A-Z][A-Z]*?!') ||
928 test "OK-117" != "$(test_eval_ "(exit 117) && $1${LF}${LF}echo OK-\$?" 3>&1)"
Junio C Hamano99a64e42017-03-22 22:43:18 -0700929 then
SZEDER Gábor165293a2018-11-19 14:13:26 +0100930 BUG "broken &&-chain or run-away HERE-DOC: $1"
Jeff Kingbb79af92015-03-20 06:05:48 -0400931 fi
Jeff King2a01ef82015-08-06 01:31:47 -0400932 trace=$trace_tmp
Jeff Kingbb79af92015-03-20 06:05:48 -0400933 fi
934
Thomas Rasta57397b2013-06-17 11:18:46 +0200935 setup_malloc_check
Jonathan Niedera7c58f22011-08-08 03:17:09 +0200936 test_eval_ "$1"
Jonathan Niederb6b0afd2010-05-06 03:41:10 -0500937 eval_ret=$?
Thomas Rasta57397b2013-06-17 11:18:46 +0200938 teardown_malloc_check
Junio C Hamanob5867442011-06-27 11:02:22 -0700939
Jeff Kinga136f6d2014-10-10 02:47:27 -0400940 if test -z "$immediate" || test $eval_ret = 0 ||
941 test -n "$expecting_failure" && test "$test_cleanup" != ":"
Junio C Hamanob5867442011-06-27 11:02:22 -0700942 then
Junio C Hamano1b3185f2012-09-14 20:38:24 -0700943 setup_malloc_check
Jonathan Niedera7c58f22011-08-08 03:17:09 +0200944 test_eval_ "$test_cleanup"
Junio C Hamano1b3185f2012-09-14 20:38:24 -0700945 teardown_malloc_check
Junio C Hamanob5867442011-06-27 11:02:22 -0700946 fi
Ramsay Jones1c0cc752012-09-01 19:11:49 +0100947 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
948 then
Ævar Arnfjörð Bjarmason57e15382010-06-24 17:44:47 +0000949 echo ""
950 fi
Jonathan Niederaa0bcf92011-08-08 03:15:34 +0200951 return "$eval_ret"
Pavel Roskin4d9d62f2005-08-10 23:56:21 -0400952}
953
Thomas Rastae753422013-06-18 14:25:59 +0200954test_start_ () {
Johannes Sixt8586f982009-02-05 21:20:56 +0100955 test_count=$(($test_count+1))
Thomas Rastff09af32013-06-23 20:12:56 +0200956 maybe_setup_verbose
Thomas Rast5dfc3682013-06-23 20:12:57 +0200957 maybe_setup_valgrind
Johannes Schindelin22231902019-01-29 06:19:27 -0800958 if test -n "$write_junit_xml"
959 then
960 junit_start=$(test-tool date getnanos)
961 fi
Thomas Rastae753422013-06-18 14:25:59 +0200962}
963
964test_finish_ () {
965 echo >&3 ""
Thomas Rast5dfc3682013-06-23 20:12:57 +0200966 maybe_teardown_valgrind
Thomas Rastff09af32013-06-23 20:12:56 +0200967 maybe_teardown_verbose
Johannes Schindelinaf9912e2019-01-29 06:19:34 -0800968 if test -n "$GIT_TEST_TEE_OFFSET"
969 then
970 GIT_TEST_TEE_OFFSET=$(test-tool path-utils file-size \
971 "$GIT_TEST_TEE_OUTPUT_FILE")
972 fi
Thomas Rastae753422013-06-18 14:25:59 +0200973}
974
975test_skip () {
Junio C Hamano04ece592006-12-28 17:58:00 -0800976 to_skip=
Ilya Bobyref2ac682014-04-30 02:50:43 -0700977 skipped_reason=
Thomas Raste6a6ddc2013-06-18 14:25:58 +0200978 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
979 then
980 to_skip=t
Ilya Bobyref2ac682014-04-30 02:50:43 -0700981 skipped_reason="GIT_SKIP_TESTS"
Thomas Raste6a6ddc2013-06-18 14:25:58 +0200982 fi
Jonathan Nieder05236a52010-10-17 02:36:58 +0800983 if test -z "$to_skip" && test -n "$test_prereq" &&
984 ! test_have_prereq "$test_prereq"
Johannes Sixta7bb3942009-03-01 21:04:46 +0100985 then
986 to_skip=t
Ilya Bobyref2ac682014-04-30 02:50:43 -0700987
Jonathan Nieder07431fc2010-08-24 02:34:10 -0500988 of_prereq=
Jonathan Nieder05236a52010-10-17 02:36:58 +0800989 if test "$missing_prereq" != "$test_prereq"
Jonathan Nieder07431fc2010-08-24 02:34:10 -0500990 then
Jonathan Nieder05236a52010-10-17 02:36:58 +0800991 of_prereq=" of $test_prereq"
Jonathan Nieder07431fc2010-08-24 02:34:10 -0500992 fi
Ilya Bobyref2ac682014-04-30 02:50:43 -0700993 skipped_reason="missing $missing_prereq${of_prereq}"
994 fi
Ilya Bobyr0445e6f2014-04-30 02:50:44 -0700995 if test -z "$to_skip" && test -n "$run_list" &&
996 ! match_test_selector_list '--run' $test_count "$run_list"
997 then
998 to_skip=t
999 skipped_reason="--run"
1000 fi
Jonathan Nieder07431fc2010-08-24 02:34:10 -05001001
Ilya Bobyref2ac682014-04-30 02:50:43 -07001002 case "$to_skip" in
1003 t)
Johannes Schindelin22231902019-01-29 06:19:27 -08001004 if test -n "$write_junit_xml"
1005 then
1006 message="$(xml_attr_encode "$skipped_reason")"
1007 write_junit_xml_testcase "$1" \
1008 " <skipped message=\"$message\" />"
1009 fi
1010
Thomas Rast633fe502013-10-19 23:06:08 +02001011 say_color skip >&3 "skipping test: $@"
Ilya Bobyref2ac682014-04-30 02:50:43 -07001012 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
Junio C Hamano04ece592006-12-28 17:58:00 -08001013 : true
1014 ;;
1015 *)
1016 false
1017 ;;
1018 esac
1019}
1020
Thomas Rast342e9ef2012-02-17 11:25:09 +01001021# stub; perf-lib overrides it
1022test_at_end_hook_ () {
1023 :
1024}
1025
Johannes Schindelin22231902019-01-29 06:19:27 -08001026write_junit_xml () {
1027 case "$1" in
1028 --truncate)
1029 >"$junit_xml_path"
1030 junit_have_testcase=
1031 shift
1032 ;;
1033 esac
1034 printf '%s\n' "$@" >>"$junit_xml_path"
1035}
1036
1037xml_attr_encode () {
1038 printf '%s\n' "$@" | test-tool xml-encode
1039}
1040
1041write_junit_xml_testcase () {
1042 junit_attrs="name=\"$(xml_attr_encode "$this_test.$test_count $1")\""
1043 shift
1044 junit_attrs="$junit_attrs classname=\"$this_test\""
1045 junit_attrs="$junit_attrs time=\"$(test-tool \
1046 date getnanos $junit_start)\""
1047 write_junit_xml "$(printf '%s\n' \
1048 " <testcase $junit_attrs>" "$@" " </testcase>")"
1049 junit_have_testcase=t
1050}
1051
Junio C Hamanoe1970ce2005-05-13 22:50:32 -07001052test_done () {
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +02001053 GIT_EXIT_OK=t
Sverre Rabbelier2d84e9f2008-06-08 16:04:33 +02001054
Johannes Schindelin22231902019-01-29 06:19:27 -08001055 if test -n "$write_junit_xml" && test -n "$junit_xml_path"
1056 then
1057 test -n "$junit_have_testcase" || {
1058 junit_start=$(test-tool date getnanos)
1059 write_junit_xml_testcase "all tests skipped"
1060 }
1061
1062 # adjust the overall time
1063 junit_time=$(test-tool date getnanos $junit_suite_start)
1064 sed "s/<testsuite [^>]*/& time=\"$junit_time\"/" \
1065 <"$junit_xml_path" >"$junit_xml_path.new"
1066 mv "$junit_xml_path.new" "$junit_xml_path"
1067
1068 write_junit_xml " </testsuite>" "</testsuites>"
1069 fi
1070
Ramsay Jones1c0cc752012-09-01 19:11:49 +01001071 if test -z "$HARNESS_ACTIVE"
1072 then
SZEDER Gábor62c379b2019-01-05 02:08:56 +01001073 mkdir -p "$TEST_RESULTS_DIR"
Ævar Arnfjörð Bjarmason8ef1abe2010-08-11 19:37:31 +00001074
SZEDER Gábor62c379b2019-01-05 02:08:56 +01001075 cat >"$TEST_RESULTS_BASE.counts" <<-EOF
Mathias Lafeldtc54e6be2011-04-29 14:30:30 +02001076 total $test_count
1077 success $test_success
1078 fixed $test_fixed
1079 broken $test_broken
1080 failed $test_failure
1081
1082 EOF
Ævar Arnfjörð Bjarmason8ef1abe2010-08-11 19:37:31 +00001083 fi
Junio C Hamano41ac4142008-02-01 01:50:53 -08001084
1085 if test "$test_fixed" != 0
1086 then
Thomas Rast633fe502013-10-19 23:06:08 +02001087 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
Junio C Hamano41ac4142008-02-01 01:50:53 -08001088 fi
1089 if test "$test_broken" != 0
1090 then
Thomas Rast633fe502013-10-19 23:06:08 +02001091 say_color warn "# still have $test_broken known breakage(s)"
Adam Spiersb73d9a22012-12-16 18:28:15 +00001092 fi
1093 if test "$test_broken" != 0 || test "$test_fixed" != 0
1094 then
1095 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
1096 msg="remaining $test_remaining test(s)"
Junio C Hamano11d54b82008-02-03 00:23:02 -08001097 else
Adam Spiersb73d9a22012-12-16 18:28:15 +00001098 test_remaining=$test_count
Junio C Hamano11d54b82008-02-03 00:23:02 -08001099 msg="$test_count test(s)"
Junio C Hamano41ac4142008-02-01 01:50:53 -08001100 fi
Junio C Hamanoe1970ce2005-05-13 22:50:32 -07001101 case "$test_failure" in
Junio C Hamano10b94e22005-12-09 17:32:18 -08001102 0)
Ramsay Jones1c0cc752012-09-01 19:11:49 +01001103 if test $test_external_has_tap -eq 0
1104 then
Adam Spiersb73d9a22012-12-16 18:28:15 +00001105 if test $test_remaining -gt 0
Ramsay Jonesd87bd7c2012-09-01 19:26:21 +01001106 then
Thomas Rast633fe502013-10-19 23:06:08 +02001107 say_color pass "# passed all $msg"
Ramsay Jonesd87bd7c2012-09-01 19:26:21 +01001108 fi
Junio C Hamanoc7018be2017-05-18 11:52:20 +09001109
1110 # Maybe print SKIP message
1111 test -z "$skip_all" || skip_all="# SKIP $skip_all"
1112 case "$test_count" in
1113 0)
1114 say "1..$test_count${skip_all:+ $skip_all}"
1115 ;;
1116 *)
1117 test -z "$skip_all" ||
1118 say_color warn "$skip_all"
1119 say "1..$test_count"
1120 ;;
1121 esac
Ævar Arnfjörð Bjarmasond998bd42010-06-24 17:44:46 +00001122 fi
Johannes Schindelinabc5d372008-08-08 13:08:37 +02001123
Junio C Hamano06478da2017-04-23 17:15:09 -07001124 if test -z "$debug"
Junio C Hamano4d0912a2017-04-24 23:39:47 -07001125 then
Junio C Hamano06478da2017-04-23 17:15:09 -07001126 test -d "$TRASH_DIRECTORY" ||
Junio C Hamano4d0912a2017-04-24 23:39:47 -07001127 error "Tests passed but trash directory already removed before test cleanup; aborting"
Johannes Schindelinabc5d372008-08-08 13:08:37 +02001128
Junio C Hamano06478da2017-04-23 17:15:09 -07001129 cd "$TRASH_DIRECTORY/.." &&
Johannes Schindelin046e90d2019-01-29 06:19:35 -08001130 rm -fr "$TRASH_DIRECTORY" || {
1131 # try again in a bit
1132 sleep 5;
1133 rm -fr "$TRASH_DIRECTORY"
1134 } ||
Junio C Hamano4d0912a2017-04-24 23:39:47 -07001135 error "Tests passed but test cleanup failed; aborting"
Junio C Hamano4d0912a2017-04-24 23:39:47 -07001136 fi
Thomas Rast342e9ef2012-02-17 11:25:09 +01001137 test_at_end_hook_
1138
Junio C Hamanoe1970ce2005-05-13 22:50:32 -07001139 exit 0 ;;
1140
1141 *)
Ramsay Jones1c0cc752012-09-01 19:11:49 +01001142 if test $test_external_has_tap -eq 0
1143 then
Thomas Rast633fe502013-10-19 23:06:08 +02001144 say_color error "# failed $test_failure among $msg"
1145 say "1..$test_count"
Ævar Arnfjörð Bjarmasond998bd42010-06-24 17:44:46 +00001146 fi
Ævar Arnfjörð Bjarmason5099b992010-06-24 21:52:12 +00001147
Junio C Hamanoe1970ce2005-05-13 22:50:32 -07001148 exit 1 ;;
1149
1150 esac
1151}
1152
Matthew Ogilviee4597aa2009-12-02 22:14:06 -07001153if test -n "$valgrind"
Johannes Schindelin4e1be632009-02-04 00:25:59 +01001154then
Johannes Schindelin4e1be632009-02-04 00:25:59 +01001155 make_symlink () {
1156 test -h "$2" &&
1157 test "$1" = "$(readlink "$2")" || {
1158 # be super paranoid
1159 if mkdir "$2".lock
1160 then
1161 rm -f "$2" &&
1162 ln -s "$1" "$2" &&
1163 rm -r "$2".lock
1164 else
1165 while test -d "$2".lock
1166 do
1167 say "Waiting for lock on $2."
1168 sleep 1
1169 done
1170 fi
1171 }
1172 }
1173
1174 make_valgrind_symlink () {
Jeff King36bfb0e2011-06-17 16:36:32 -04001175 # handle only executables, unless they are shell libraries that
Jonathan Nieder11d62142013-11-25 13:03:52 -08001176 # need to be in the exec-path.
Jeff King36bfb0e2011-06-17 16:36:32 -04001177 test -x "$1" ||
Ævar Arnfjörð Bjarmason2a59a6e2018-08-24 15:20:11 +00001178 test "# " = "$(test_copy_bytes 2 <"$1")" ||
Jeff King36bfb0e2011-06-17 16:36:32 -04001179 return;
Johannes Schindelin4e1be632009-02-04 00:25:59 +01001180
1181 base=$(basename "$1")
René Scharfe28fab7b2016-10-28 00:14:00 +02001182 case "$base" in
1183 test-*)
1184 symlink_target="$GIT_BUILD_DIR/t/helper/$base"
1185 ;;
1186 *)
1187 symlink_target="$GIT_BUILD_DIR/$base"
1188 ;;
1189 esac
Johannes Schindelin4e1be632009-02-04 00:25:59 +01001190 # do not override scripts
1191 if test -x "$symlink_target" &&
1192 test ! -d "$symlink_target" &&
Ævar Arnfjörð Bjarmason2a59a6e2018-08-24 15:20:11 +00001193 test "#!" != "$(test_copy_bytes 2 <"$symlink_target")"
Johannes Schindelin4e1be632009-02-04 00:25:59 +01001194 then
1195 symlink_target=../valgrind.sh
1196 fi
Johannes Schindelinefd92ff2009-02-04 00:26:08 +01001197 case "$base" in
1198 *.sh|*.perl)
1199 symlink_target=../unprocessed-script
1200 esac
Johannes Schindelin4e1be632009-02-04 00:25:59 +01001201 # create the link, or replace it if it is out of date
1202 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
1203 }
1204
Thomas Rast26a07302013-10-19 23:06:07 +02001205 # override all git executables in TEST_DIRECTORY/..
1206 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
1207 mkdir -p "$GIT_VALGRIND"/bin
Johannes Schindelin503e2242016-07-11 13:45:08 +02001208 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
Thomas Rast26a07302013-10-19 23:06:07 +02001209 do
1210 make_valgrind_symlink $file
1211 done
1212 # special-case the mergetools loadables
1213 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
1214 OLDIFS=$IFS
1215 IFS=:
1216 for path in $PATH
1217 do
1218 ls "$path"/git-* 2> /dev/null |
1219 while read file
Johannes Schindelinefd92ff2009-02-04 00:26:08 +01001220 do
Thomas Rast26a07302013-10-19 23:06:07 +02001221 make_valgrind_symlink "$file"
Johannes Schindelinefd92ff2009-02-04 00:26:08 +01001222 done
Thomas Rast26a07302013-10-19 23:06:07 +02001223 done
1224 IFS=$OLDIFS
Johannes Schindelin4e1be632009-02-04 00:25:59 +01001225 PATH=$GIT_VALGRIND/bin:$PATH
1226 GIT_EXEC_PATH=$GIT_VALGRIND/bin
1227 export GIT_VALGRIND
Thomas Rast952af352013-03-31 10:00:16 +02001228 GIT_VALGRIND_MODE="$valgrind"
1229 export GIT_VALGRIND_MODE
Thomas Rast5dfc3682013-06-23 20:12:57 +02001230 GIT_VALGRIND_ENABLED=t
Thomas Rast26a07302013-10-19 23:06:07 +02001231 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
Thomas Rast5dfc3682013-06-23 20:12:57 +02001232 export GIT_VALGRIND_ENABLED
Ramsay Jones1c0cc752012-09-01 19:11:49 +01001233elif test -n "$GIT_TEST_INSTALLED"
1234then
Matthew Ogilviee4597aa2009-12-02 22:14:06 -07001235 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
1236 error "Cannot run git from $GIT_TEST_INSTALLED."
Johannes Schindelin16df35c2018-11-12 05:48:33 -08001237 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR/t/helper:$PATH
Matthew Ogilviee4597aa2009-12-02 22:14:06 -07001238 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
1239else # normal case, use ../bin-wrappers only unless $with_dashes:
Johannes Schindelindd167a32019-01-29 06:19:37 -08001240 if test -n "$no_bin_wrappers"
Ramsay Jones1c0cc752012-09-01 19:11:49 +01001241 then
Matthew Ogilviee4597aa2009-12-02 22:14:06 -07001242 with_dashes=t
Johannes Schindelindd167a32019-01-29 06:19:37 -08001243 else
1244 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1245 if ! test -x "$git_bin_dir/git"
1246 then
1247 if test -z "$with_dashes"
1248 then
1249 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
1250 fi
1251 with_dashes=t
1252 fi
1253 PATH="$git_bin_dir:$PATH"
Matthew Ogilviee4597aa2009-12-02 22:14:06 -07001254 fi
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +00001255 GIT_EXEC_PATH=$GIT_BUILD_DIR
Ramsay Jones1c0cc752012-09-01 19:11:49 +01001256 if test -n "$with_dashes"
1257 then
Johannes Schindelinca7312d2019-01-29 06:19:35 -08001258 PATH="$GIT_BUILD_DIR:$GIT_BUILD_DIR/t/helper:$PATH"
Matthew Ogilviee4597aa2009-12-02 22:14:06 -07001259 fi
Johannes Schindelin4e1be632009-02-04 00:25:59 +01001260fi
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +00001261GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
Jeff King8bfa6bd2008-02-06 05:11:53 -05001262GIT_CONFIG_NOSYSTEM=1
Jonathan Nieder3c995be2011-03-15 04:05:10 -05001263GIT_ATTR_NOSYSTEM=1
Jonathan Nieder8f323c02011-03-15 04:04:49 -05001264export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
Junio C Hamano49ccb082005-12-07 21:52:28 -08001265
Junio C Hamano5e87eae2010-06-11 09:40:25 -07001266if test -z "$GIT_TEST_CMP"
1267then
1268 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
1269 then
1270 GIT_TEST_CMP="$DIFF -c"
1271 else
1272 GIT_TEST_CMP="$DIFF -u"
1273 fi
1274fi
1275
Ævar Arnfjörð Bjarmason20d2a302017-12-10 21:13:33 +00001276GITPERLLIB="$GIT_BUILD_DIR"/perl/build/lib
Petr Baudis6fcca932006-07-03 23:16:32 +02001277export GITPERLLIB
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +00001278test -d "$GIT_BUILD_DIR"/templates/blt || {
Junio C Hamanoeea42062005-12-10 20:55:32 -08001279 error "You haven't built things yet, have you?"
1280}
Junio C Hamanoe1970ce2005-05-13 22:50:32 -07001281
Johannes Schindelind6096152019-01-21 07:12:19 -08001282if ! test -x "$GIT_BUILD_DIR"/t/helper/test-tool$X
Ramsay Jones1c0cc752012-09-01 19:11:49 +01001283then
Nguyễn Thái Ngọc Duy0e496492018-03-24 08:44:31 +01001284 echo >&2 'You need to build test-tool:'
1285 echo >&2 'Run "make t/helper/test-tool" in the source (toplevel) directory'
Eric Wong56cf9802007-02-24 16:59:52 -08001286 exit 1
1287fi
1288
Junio C Hamanoe1970ce2005-05-13 22:50:32 -07001289# Test repository
John Keeping38b074d2013-04-14 17:34:56 +01001290rm -fr "$TRASH_DIRECTORY" || {
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +02001291 GIT_EXIT_OK=t
Junio C Hamano8d14ac92008-03-18 21:58:01 -07001292 echo >&5 "FATAL: Cannot prepare test area"
1293 exit 1
1294}
1295
Alex Riesen90cff962011-03-26 19:46:34 +01001296HOME="$TRASH_DIRECTORY"
Junio C Hamano0ea47f92014-09-15 14:59:00 -07001297GNUPGHOME="$HOME/gnupg-home-not-used"
1298export HOME GNUPGHOME
Alex Riesen90cff962011-03-26 19:46:34 +01001299
Ramsay Jones1c0cc752012-09-01 19:11:49 +01001300if test -z "$TEST_NO_CREATE_REPO"
1301then
John Keeping38b074d2013-04-14 17:34:56 +01001302 test_create_repo "$TRASH_DIRECTORY"
Thomas Rast342e9ef2012-02-17 11:25:09 +01001303else
John Keeping38b074d2013-04-14 17:34:56 +01001304 mkdir -p "$TRASH_DIRECTORY"
Thomas Rast342e9ef2012-02-17 11:25:09 +01001305fi
Johannes Schindelin22231902019-01-29 06:19:27 -08001306
Lea Wiemann1bd9c642008-05-31 23:11:21 +02001307# Use -P to resolve symlinks in our working directory so that the cwd
1308# in subprocesses like git equals our $PWD (for pathname comparisons).
John Keeping38b074d2013-04-14 17:34:56 +01001309cd -P "$TRASH_DIRECTORY" || exit 1
Junio C Hamano04ece592006-12-28 17:58:00 -08001310
Johannes Sixtd5d9de12009-02-05 20:59:27 +01001311this_test=${0##*/}
1312this_test=${this_test%%-*}
Thomas Raste6a6ddc2013-06-18 14:25:58 +02001313if match_pattern_list "$this_test" $GIT_SKIP_TESTS
1314then
1315 say_color info >&3 "skipping test $this_test altogether"
1316 skip_all="skip all tests in $this_test"
1317 test_done
1318fi
Johannes Sixtf17e9fb2009-03-11 21:17:26 +01001319
Johannes Schindelin22231902019-01-29 06:19:27 -08001320if test -n "$write_junit_xml"
1321then
1322 junit_xml_dir="$TEST_OUTPUT_DIRECTORY/out"
1323 mkdir -p "$junit_xml_dir"
1324 junit_xml_base=${0##*/}
1325 junit_xml_path="$junit_xml_dir/TEST-${junit_xml_base%.sh}.xml"
1326 junit_attrs="name=\"${junit_xml_base%.sh}\""
1327 junit_attrs="$junit_attrs timestamp=\"$(TZ=UTC \
1328 date +%Y-%m-%dT%H:%M:%S)\""
1329 write_junit_xml --truncate "<testsuites>" " <testsuite $junit_attrs>"
1330 junit_suite_start=$(test-tool date getnanos)
Johannes Schindelinaf9912e2019-01-29 06:19:34 -08001331 if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
1332 then
1333 GIT_TEST_TEE_OFFSET=0
1334 fi
Johannes Schindelin22231902019-01-29 06:19:27 -08001335fi
1336
Junio C Hamano11f470a2019-02-09 10:25:26 -08001337# Provide an implementation of the 'yes' utility; the upper bound
1338# limit is there to help Windows that cannot stop this loop from
1339# wasting cycles when the downstream stops reading, so do not be
1340# tempted to turn it into an infinite loop. cf. 6129c930 ("test-lib:
1341# limit the output of the yes utility", 2016-02-02)
Brandon Casey86487322009-08-28 17:32:41 -05001342yes () {
1343 if test $# = 0
1344 then
1345 y=y
1346 else
1347 y="$*"
1348 fi
1349
Johannes Schindelin6129c932016-02-02 19:15:53 +01001350 i=0
1351 while test $i -lt 99
Brandon Casey86487322009-08-28 17:32:41 -05001352 do
Johannes Schindelin6129c932016-02-02 19:15:53 +01001353 echo "$y"
1354 i=$(($i+1))
Brandon Casey86487322009-08-28 17:32:41 -05001355 done
1356}
1357
Johannes Sixtf17e9fb2009-03-11 21:17:26 +01001358# Fix some commands on Windows
Johannes Schindelind98b2c52016-07-21 18:02:54 +02001359uname_s=$(uname -s)
1360case $uname_s in
Johannes Sixtf17e9fb2009-03-11 21:17:26 +01001361*MINGW*)
1362 # Windows has its own (incompatible) sort and find
1363 sort () {
1364 /usr/bin/sort "$@"
1365 }
1366 find () {
1367 /usr/bin/find "$@"
1368 }
Johannes Sixt41141562009-03-13 23:35:24 +01001369 # git sees Windows-style pwd
1370 pwd () {
1371 builtin pwd -W
1372 }
Johannes Sixtee9fb682009-03-13 22:55:27 +01001373 # no POSIX permissions
Johannes Sixt6fd11062009-03-13 23:00:15 +01001374 # backslashes in pathspec are converted to '/'
Johannes Sixtfb9a2be2009-03-25 13:21:15 +01001375 # exec does not inherit the PID
Pat Thoytsa94114a2010-09-12 10:37:24 +01001376 test_set_prereq MINGW
Brice Lambson5f4e02e2014-08-30 23:39:07 +02001377 test_set_prereq NATIVE_CRLF
Ramsay Jonesa31d0662010-12-14 18:32:12 +00001378 test_set_prereq SED_STRIPS_CR
Mark Levedahl97669ee2013-07-18 17:44:57 -04001379 test_set_prereq GREP_STRIPS_CR
Johannes Sixt4d715ac2013-10-26 21:17:15 +02001380 GIT_TEST_CMP=mingw_test_cmp
Ramsay Jonesa31d0662010-12-14 18:32:12 +00001381 ;;
1382*CYGWIN*)
1383 test_set_prereq POSIXPERM
Ramsay Jonesa31d0662010-12-14 18:32:12 +00001384 test_set_prereq EXECKEEPSPID
Pete Wyckoffcfa96492013-01-26 22:11:11 -05001385 test_set_prereq CYGWIN
Ramsay Jonesa31d0662010-12-14 18:32:12 +00001386 test_set_prereq SED_STRIPS_CR
Mark Levedahl97669ee2013-07-18 17:44:57 -04001387 test_set_prereq GREP_STRIPS_CR
Johannes Sixtee9fb682009-03-13 22:55:27 +01001388 ;;
1389*)
1390 test_set_prereq POSIXPERM
Johannes Sixt6fd11062009-03-13 23:00:15 +01001391 test_set_prereq BSLASHPSPEC
Johannes Sixtfb9a2be2009-03-25 13:21:15 +01001392 test_set_prereq EXECKEEPSPID
Johannes Sixtf17e9fb2009-03-11 21:17:26 +01001393 ;;
1394esac
Johannes Sixt704a3142009-03-04 22:38:24 +01001395
Zbigniew Jędrzejewski-Szmekb0826872012-04-27 11:25:25 +02001396( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
Jeff King1b19ccd2009-04-03 15:33:59 -04001397test -z "$NO_PERL" && test_set_prereq PERL
Ævar Arnfjörð Bjarmason68c7d272017-05-25 19:45:31 +00001398test -z "$NO_PTHREADS" && test_set_prereq PTHREADS
Johan Herlandd4e1b472009-11-18 02:42:31 +01001399test -z "$NO_PYTHON" && test_set_prereq PYTHON
Ævar Arnfjörð Bjarmason94da9192017-06-01 18:20:56 +00001400test -n "$USE_LIBPCRE1$USE_LIBPCRE2" && test_set_prereq PCRE
Ævar Arnfjörð Bjarmasonce9a2572017-11-23 14:16:57 +00001401test -n "$USE_LIBPCRE1" && test_set_prereq LIBPCRE1
1402test -n "$USE_LIBPCRE2" && test_set_prereq LIBPCRE2
Ævar Arnfjörð Bjarmason5e9637c2011-11-18 00:14:42 +01001403test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
Jeff King1b19ccd2009-04-03 15:33:59 -04001404
Ævar Arnfjörð Bjarmason6cdccfc2018-11-08 21:15:29 +00001405if test -n "$GIT_TEST_GETTEXT_POISON_ORIG"
Jonathan Nieder30955222011-02-22 23:41:22 +00001406then
Ævar Arnfjörð Bjarmason6cdccfc2018-11-08 21:15:29 +00001407 GIT_TEST_GETTEXT_POISON=$GIT_TEST_GETTEXT_POISON_ORIG
1408 unset GIT_TEST_GETTEXT_POISON_ORIG
1409fi
1410
1411# Can we rely on git's output in the C locale?
1412if test -z "$GIT_TEST_GETTEXT_POISON"
1413then
Jonathan Nieder30955222011-02-22 23:41:22 +00001414 test_set_prereq C_LOCALE_OUTPUT
1415fi
Ævar Arnfjörð Bjarmasonbb946bb2011-02-22 23:41:21 +00001416
Nguyễn Thái Ngọc Duy4592e602018-08-18 16:41:28 +02001417if test -z "$GIT_TEST_CHECK_CACHE_TREE"
1418then
1419 GIT_TEST_CHECK_CACHE_TREE=true
1420 export GIT_TEST_CHECK_CACHE_TREE
1421fi
1422
Adam Spiers20073272013-04-11 03:07:04 +01001423test_lazy_prereq PIPE '
1424 # test whether the filesystem supports FIFOs
Ramsay Jones7b7bea22017-09-17 23:56:00 +01001425 test_have_prereq !MINGW,!CYGWIN &&
1426 rm -f testfifo && mkfifo testfifo
Adam Spiers20073272013-04-11 03:07:04 +01001427'
1428
Junio C Hamano04083f22012-07-26 15:50:45 -07001429test_lazy_prereq SYMLINKS '
1430 # test whether the filesystem supports symbolic links
1431 ln -s x y && test -h y
1432'
Ævar Arnfjörð Bjarmasonc91cfd12010-08-06 22:09:09 +00001433
Jonathan Niederb018c732013-11-25 13:02:16 -08001434test_lazy_prereq FILEMODE '
1435 test "$(git config --bool core.filemode)" = true
1436'
1437
Michael J Gruberac39aa62012-07-26 15:39:53 +02001438test_lazy_prereq CASE_INSENSITIVE_FS '
1439 echo good >CamelCase &&
1440 echo bad >camelcase &&
1441 test "$(cat CamelCase)" != good
1442'
1443
William Chargin6ec63302018-08-06 11:35:08 -07001444test_lazy_prereq FUNNYNAMES '
1445 test_have_prereq !MINGW &&
1446 touch -- \
1447 "FUNNYNAMES tab embedded" \
1448 "FUNNYNAMES \"quote embedded\"" \
1449 "FUNNYNAMES newline
1450embedded" 2>/dev/null &&
1451 rm -- \
1452 "FUNNYNAMES tab embedded" \
1453 "FUNNYNAMES \"quote embedded\"" \
1454 "FUNNYNAMES newline
1455embedded" 2>/dev/null
1456'
1457
Michael J Gruber5b0b5dd2012-07-26 15:39:56 +02001458test_lazy_prereq UTF8_NFD_TO_NFC '
1459 # check whether FS converts nfd unicode to nfc
1460 auml=$(printf "\303\244")
1461 aumlcdiar=$(printf "\141\314\210")
1462 >"$auml" &&
Torsten Bögershausen742ae102018-04-30 08:35:19 +02001463 test -f "$aumlcdiar"
Michael J Gruber5b0b5dd2012-07-26 15:39:56 +02001464'
1465
Jeff King09feffb2012-11-14 16:33:40 -08001466test_lazy_prereq AUTOIDENT '
1467 sane_unset GIT_AUTHOR_NAME &&
1468 sane_unset GIT_AUTHOR_EMAIL &&
1469 git var GIT_AUTHOR_IDENT
1470'
1471
Junio C Hamano6219bb22014-06-09 12:23:30 -07001472test_lazy_prereq EXPENSIVE '
1473 test -n "$GIT_TEST_LONG"
1474'
1475
Ævar Arnfjörð Bjarmason5b1fe6e2018-01-30 21:21:23 +00001476test_lazy_prereq EXPENSIVE_ON_WINDOWS '
1477 test_have_prereq EXPENSIVE || test_have_prereq !MINGW,!CYGWIN
1478'
1479
Junio C Hamanoe1ecd9e2014-06-09 13:54:25 -07001480test_lazy_prereq USR_BIN_TIME '
1481 test -x /usr/bin/time
1482'
1483
Jeff King1767c512015-01-16 04:16:49 -05001484test_lazy_prereq NOT_ROOT '
1485 uid=$(id -u) &&
1486 test "$uid" != 0
1487'
1488
Jonathan Tan63b747c2016-09-09 10:36:28 -07001489test_lazy_prereq JGIT '
1490 type jgit
1491'
1492
Junio C Hamano719c3da2016-01-19 14:09:37 -08001493# SANITY is about "can you correctly predict what the filesystem would
1494# do by only looking at the permission bits of the files and
1495# directories?" A typical example of !SANITY is running the test
1496# suite as root, where a test may expect "chmod -r file && cat file"
1497# to fail because file is supposed to be unreadable after a successful
1498# chmod. In an environment (i.e. combination of what filesystem is
1499# being used and who is running the tests) that lacks SANITY, you may
1500# be able to delete or create a file when the containing directory
1501# doesn't have write permissions, or access a file even if the
1502# containing directory doesn't have read or execute permissions.
1503
Torsten Bögershausenf400e512015-01-27 16:39:01 +01001504test_lazy_prereq SANITY '
1505 mkdir SANETESTD.1 SANETESTD.2 &&
1506
1507 chmod +w SANETESTD.1 SANETESTD.2 &&
1508 >SANETESTD.1/x 2>SANETESTD.2/x &&
1509 chmod -w SANETESTD.1 &&
Junio C Hamano719c3da2016-01-19 14:09:37 -08001510 chmod -r SANETESTD.1/x &&
Torsten Bögershausenf400e512015-01-27 16:39:01 +01001511 chmod -rx SANETESTD.2 ||
SZEDER Gábor165293a2018-11-19 14:13:26 +01001512 BUG "cannot prepare SANETESTD"
Torsten Bögershausenf400e512015-01-27 16:39:01 +01001513
Junio C Hamano719c3da2016-01-19 14:09:37 -08001514 ! test -r SANETESTD.1/x &&
Torsten Bögershausenf400e512015-01-27 16:39:01 +01001515 ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1516 status=$?
1517
1518 chmod +rwx SANETESTD.1 SANETESTD.2 &&
1519 rm -rf SANETESTD.1 SANETESTD.2 ||
SZEDER Gábor165293a2018-11-19 14:13:26 +01001520 BUG "cannot clean SANETESTD"
Torsten Bögershausenf400e512015-01-27 16:39:01 +01001521 return $status
1522'
Jeff Kingf838ce52013-03-10 21:31:47 -04001523
Johannes Schindelind98b2c52016-07-21 18:02:54 +02001524test FreeBSD != $uname_s || GIT_UNZIP=${GIT_UNZIP:-/usr/local/bin/unzip}
Jeff Kingf838ce52013-03-10 21:31:47 -04001525GIT_UNZIP=${GIT_UNZIP:-unzip}
1526test_lazy_prereq UNZIP '
1527 "$GIT_UNZIP" -v
1528 test $? -ne 127
1529'
Jeff King9a308de2015-03-13 00:53:07 -04001530
1531run_with_limited_cmdline () {
1532 (ulimit -s 128 && "$@")
1533}
1534
Ramsay Jones21dac1d2017-09-14 18:24:41 +01001535test_lazy_prereq CMDLINE_LIMIT '
1536 test_have_prereq !MINGW,!CYGWIN &&
1537 run_with_limited_cmdline true
1538'
Jeff King6b9c38e2016-07-11 19:54:18 -04001539
Michael J Gruber4db464f2017-09-07 16:02:20 +02001540run_with_limited_stack () {
1541 (ulimit -s 128 && "$@")
1542}
1543
Ramsay Jones21dac1d2017-09-14 18:24:41 +01001544test_lazy_prereq ULIMIT_STACK_SIZE '
1545 test_have_prereq !MINGW,!CYGWIN &&
1546 run_with_limited_stack true
1547'
Michael J Gruber4db464f2017-09-07 16:02:20 +02001548
Jeff King6b9c38e2016-07-11 19:54:18 -04001549build_option () {
1550 git version --build-options |
1551 sed -ne "s/^$1: //p"
1552}
1553
1554test_lazy_prereq LONG_IS_64BIT '
1555 test 8 -le "$(build_option sizeof-long)"
1556'
Johannes Schindelina07fb052017-04-20 22:52:13 +02001557
Nguyễn Thái Ngọc Duya801a7c2018-03-24 08:44:36 +01001558test_lazy_prereq TIME_IS_64BIT 'test-tool date is64bit'
1559test_lazy_prereq TIME_T_IS_64BIT 'test-tool date time_t-is64bit'
Jeff Kinge9184b02018-04-03 10:01:57 -04001560
1561test_lazy_prereq CURL '
1562 curl --version
1563'
brian m. carlsond16ab632018-05-13 02:24:11 +00001564
1565# SHA1 is a test if the hash algorithm in use is SHA-1. This is both for tests
1566# which will not work with other hash algorithms and tests that work but don't
1567# test anything meaningful (e.g. special values which cause short collisions).
1568test_lazy_prereq SHA1 '
1569 test $(git hash-object /dev/null) = e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
1570'
Johannes Schindelin11aad462018-10-31 13:02:02 -07001571
1572test_lazy_prereq REBASE_P '
1573 test -z "$GIT_TEST_SKIP_REBASE_P"
1574'